{	This program is copyright (c) 1995 - 2005 Jos Kunst, the Jos Kunst heirs.	}
{	This program is free software. You can redistribute it and/or modify it 	}
{	under the terms of version 2 of the GNU General Public License, which you	}
{	should have received with it.												}
{	This program is distributed in the hope that it will be useful, but			}
{	without any warranty, expressed or implied.									}

program brass (output);
	uses
		translations;
	type
		triad = array[1..3] of byte;
{order: trbn, cor, trp}
	var
		lasttriad, nexttriad: triad;
		p, newroot, trumpettone, horntone, trombonetone: byte;
		enough: boolean;
		rootstring, tonestring: pitchstring;
		fullScreen: rect;

	procedure donexttriad (lastt: triad; var nextt: triad; nextr: byte);
		type
			distriad = array[1..6] of triad;
{order:  1: 153}
{            2: 135}
{            3: 315}
{            4: 351}
{            5: 513}
{            6: 531}

		var
			sumdiff, p, q, s: byte;
			listofnextt: distriad;
			stepsok: boolean;

		procedure finddistributions (hr: byte; var distrib: distriad);
			var
				trptop, trpbot, cortop, corbot, trbntop, trbnbot, p, q: byte;
		begin{finddistributions}
			for p := 1 to 6 do
				for q := 1 to 3 do
					distrib[p][q] := 0;
			trptop := 77;
{was: lasttriad[ 3 ] + 5 }
			trpbot := 69;
{was: lasttriad[3] - 5}
			cortop := 73;
{was: lasttriad[2] + 5}
			corbot := 65;
{was: lasttriad[2] - 5}
			trbntop := 45;
{was: lasttriad[1] + 5}
			trbnbot := 37;
{was: lasttriad[1] - 5}
			p := hr;
{-------bereken mogelijke tonen voor trombone ----------}
			while p >= trbnbot - 7 do
				p := p - 12;
			repeat
				p := p + 12;
				q := 0;
				repeat
					if (p + q >= trbnbot) and (p + q <= trbntop) then
						begin
							if q = 0 then
								begin
									distrib[1][1] := p + q;
									distrib[2][1] := p + q
								end
							else if q = 3 then
								begin
									distrib[3][1] := p + q;
									distrib[4][1] := p + q
								end
							else if q = 7 then
								begin
									distrib[5][1] := p + q;
									distrib[6][1] := p + q
								end
						end;
					if q = 0 then
						q := 3
					else
						q := q + 4
				until q > 7
			until p > trbntop;
{---------- ...  voor hoorn ...------------}
			while p >= corbot - 7 do
				p := p - 12;
			repeat
				p := p + 12;
				q := 0;
				repeat
					if (p + q >= corbot) and (p + q <= cortop) then
						begin
							if q = 0 then
								begin
									distrib[3][2] := p + q;
									distrib[5][2] := p + q
								end
							else if q = 3 then
								begin
									distrib[2][2] := p + q;
									distrib[6][2] := p + q
								end
							else if q = 7 then
								begin
									distrib[1][2] := p + q;
									distrib[4][2] := p + q
								end
						end;
					if q = 0 then
						q := 3
					else
						q := q + 4
				until q > 7
			until p > cortop;
{-------- ...en tenslotte voor trompet -------------}
			while p >= trpbot - 7 do
				p := p - 12;
			repeat
				p := p + 12;
				q := 0;
				repeat
					if (p + q >= trpbot) and (p + q <= trptop) then
						begin
							if q = 0 then
								begin
									distrib[4][3] := p + q;
									distrib[6][3] := p + q
								end
							else if q = 3 then
								begin
									distrib[1][3] := p + q;
									distrib[5][3] := p + q
								end
							else if q = 7 then
								begin
									distrib[2][3] := p + q;
									distrib[3][3] := p + q
								end
						end;
					if q = 0 then
						q := 3
					else
						q := q + 4
				until q > 7
			until p > trptop
		end;{finddistributions}

	begin{donexttriad}
		finddistributions(nextr, listofnextt);
		stepsok := FALSE;
		repeat
{--- bepaal de aansluiting met de kleinste intervalsom ---}
			sumdiff := 250;
			for p := 1 to 6 do
				begin
					s := abs(lastt[1] - listofnextt[p][1]) + (abs(lastt[2] - listofnextt[p][2]) + abs(lastt[3] - listofnextt[p][3]));
					if s < sumdiff then
						begin
							sumdiff := s;
							q := p
						end
				end;
{------ en verwerp parallelbeweging ---------}
			if lastt[1] - listofnextt[q][1] = lastt[2] - listofnextt[q][2] then
				for p := 1 to 3 do
					listofnextt[q][p] := 0
			else
				stepsok := TRUE
		until stepsok;
		nextt := listofnextt[q];
		writeln('trumpet: ', nextt[3] - lastt[3] : 1, ' --> ', nameof(nextt[3]));
		writeln('horn: ', nextt[2] - lastt[2] : 1, ' --> ', nameof(nextt[2]));
		write('trombone: ', nextt[1] - lastt[1] : 1, ' --> ', nameof(nextt[1]));
	end;{donexttriad}

begin{main}
	SetRect(fullScreen, 9, 44, 502, 336);
	SetTextRect(fullScreen);
	ShowText;
	write('Trumpet tone-->');
	readln(tonestring);
	makeintobyte(tonestring, trumpettone);
	lasttriad[3] := trumpettone;
	write('Horn tone-->');
	readln(tonestring);
	makeintobyte(tonestring, horntone);
	lasttriad[2] := horntone;
	write('Trombone tone-->');
	readln(tonestring);
	makeintobyte(tonestring, trombonetone);
	lasttriad[1] := trombonetone;
	writeln('Starting position: trp: ', nameof(lasttriad[3]), ', cor: ', nameof(lasttriad[2]), ', trbn: ', nameof(lasttriad[1]));
	enough := FALSE;
	repeat
		write(' ... - the next HR is ');
		readln(rootstring);
		taketobyteclass(rootstring, newroot);
		if newroot = 0 then
			enough := TRUE
		else
			donexttriad(lasttriad, nexttriad, newroot);
		lasttriad := nexttriad;
	until enough
end.{main}